## Overview of the Apache TPF Port

[ Configuration Files | What's Available | CGI Scripts | Options | Syslog | Porting Notes ]

This version of Apache includes changes allowing it to run on IBM's EBCDIC-based TPF (Transaction Processing Facility) operating system.
Unless otherwise noted TPF version 4.1 PUT09 is required.

Refer to install-tpf.html for step-by-step installation instructions.

This port builds upon the EBCDIC changes previously made to Apache.

## Apache Configuration Files

The distributed configuration files (httpd.conf-dist and mime.types, both located in the conf subdirectory) work on TPF. Performance considerations may dictate setting KeepAlive to "Off" (the default is "On") or lowering the Timeout value from the default 300 seconds (5 minutes) in order to reduce the number of active ECBs on your system.

Apache on TPF does not support listening on multiple ports.

## What's Available in this Version

The Apache organization provides online documentation describing the various modules and components of the server.

### Components/modules tested on TPF:

- alloc.c
- ap_base64.c
- ap_checkpass.c
- ap_cpystrn.c
- ap_ebcdic.c
- ap_fnmatch.c
- ap_md5c.c
- ap_sha1.c
- ap_signal.c
- ap_slack.c
- ap_snprintf.c
- buff.c
- buildmark.c
- gen_test.char.c
- gen_uri_delims.c
- htpasswd.c (requires PUT10)
- http_config.c
- http_core.c
- http_log.c
- http_main.c
- http_protocol.c
- http_request.c
- http_vhost.c
- logresolve.c (requires PUT10)
- mod_access.c (Use of mod_access directives "`allow from`" & "`deny from`" with host names (versus ip addresses) requires PUT10)
- mod_actions.c
- mod_alias.c
- mod_asis.c
- mod_auth.c
- mod_auth_anon.c
- mod_autoindex.c
- mod_cern_meta.c
- mod_cgi.c (requires PUT10)
- mod_digest.c
- mod_dir.c
- mod_env.c
- mod_example.c
- mod_expires.c
- mod_headers.c
- mod_imap.c
- mod_include.c (CGI execution requires TPF version 4.1 PUT10)
- mod_info.c
- mod_log_agent.c
- mod_log_config.c
- mod_log_referer.c
- mod_mime.c
- mod_mime_magic.c
- mod_negotiation.c
- mod_put.c (third party module)
- mod_proxy.c
- mod_setenvif.c
- mod_speling.c
- mod_status.c
- mod_tpf_shm_static.c (third party module, requires PUT10)
- mod_unique_id.c (requires PUT10)
- mod_userdir.c
- mod_usertrack.c
- os.c
- os-inline.c
- proxy_cache.c
- proxy_connect.c
- proxy_ftp.c
- proxy_http.c
- proxy_util.c
- regular expression parser
- regular expression test tool (requires PUT10)
- rfc1413.c
- rotatelogs.c (requires PUT10; if PJ27214 implemented be sure to apply PJ28367)
- syslog (requires PUT13; see install and usage instructions)
- util.c
- util_date.c
- util_md5.c
- util_script.c
- util_uri.c

### Components/modules not yet supported on TPF:

- htdigest.c
- lib/expat-lite
- lib/sdbm
- mod_auth_digest.c
- mod_rewrite.c
- mod_vhost_alias.c

### Components/modules that don't apply or that probably won't ever be available on TPF:

- ab.c
- ap_getpass.c
- mod_auth_db.c
- mod_auth_dbm.c
- mod_auth_db.module
- mod_mmap_static.c
- mod_so.c
- suexec.c

## How to Use CGI Scripts

The following is a very simple example of a CGI script ("Hello World") and the necessary steps to run it.
Refer to the mod_cgi module for additional information.

### Add necessary directives to httpd.conf:

Example: `
`
`ScriptLog logs/script_log
ScriptAlias /cgi-bin/ /usr/local/apache/cgi-bin/`
A request for `http://myserver/cgi-bin/filename.cgi` would cause the server to run the script `/usr/local/apache/cgi-bin/filename.cgi`

### Create the CGI script:

For this example `QZZ1` is the name of the TPF program that will be executed by the CGI script.
The directory path must match what is in the httpd.conf file for `ScriptAlias` directive.

`zfile echo "#!QZZ1" > /usr/local/apache/cgi-bin/filename.cgi
zfile cat /usr/local/apache/cgi-bin/filename.cgi` (this should display `#!QZZ1`)

### Mark the script as executable:

`zfile chmod 755 /usr/local/apache/cgi-bin/filename.cgi
`

### Create, load, and activate a loadset containing the CGI program (QZZ1xx):

`/** QZZ1-- simple "Hello world" program to demonstrate basic CGI output **/
#include <stdio.h>
void main() {
`
`/** Print the CGI response header, required for all HTML output. **/
/** Note the extra \n, to send the blank line. **/
printf("Content-type: text/html\n\n");
/** Print the HTML response page to stdout. **/
printf("<html>\n");
printf("<head><title> CGI Output </title></head>\n");
printf("<body>\n");
printf("<h1> Hello world </h1> \n");
printf("</body>\n");
printf("</html>\n");
`
`}
`

### Request the CGI script from a browser:

`http://myserver/cgi-bin/filename.cgi`

## How to Use Apache's "Dash" Options

### Overview of Apache's "dash" options:

Apache can be invoked with various options, such as "-f". Some of these options display information about the server or perform syntax checks but they don't actually start the server. These "information only" options are useful with TPF's ZFILE command line feature: -h, -l, -L, -S, -t, -T, -v, and -V.

Another option, -X, is used when actually running the server. It is passed to Apache through the ZINET XPARM field since ZINET is the only way to start the server on TPF.

A third group of options apply to both the informational displays (ZFILE) and running the server (ZINET XPARM): -d, -D and -f.

The rest of Apache's options are either not applicable or are not supported on TPF.

Using dash options requires PJ27277 which shipped on PUT13.

### Table of supported Apache options

Option | ZFILE | ZINET | Description
-d path | ZFILE | ZINET | Set the initial value for the ServerRoot directive.
-D define | ZFILE | ZINET | Set a configuration parameter which can be used with <IfDefine>...</IfDefine> sections in the configuration file to conditionally skip or process commands.
-f filename | ZFILE | ZINET | Use an alternate configuration file instead of the default conf/httpd.conf file.
-h | ZFILE |  | List a short summary of available command line options then exit. Note that this outputs all options, not just those supported on TPF.
-l | ZFILE |  | List modules compiled into the server then exit.
-L | ZFILE |  | List available configuration directives then exit. Note that this outputs all configuration directives, not just those supported on TPF.
-S | ZFILE |  | Show the settings as parsed from the configuration file then exit. Currently Apache only shows the virtual host settings.
-t | ZFILE |  | Run syntax tests for configuration files with document root checks then exit.
-T | ZFILE |  | Run syntax tests for configuration files without document root checks then exit.
-v | ZFILE |  | Show the version number then exit.
-V | ZFILE |  | Show the version number and various compile settings then exit.
-X |  | ZINET | Run in single-process mode for internal debugging purposes only. The parent process does not fork any children.

See http://httpd.apache.org/docs/programs/httpd.html for more information about these command line options.

### Setup for ZFILE examples

Ensure Apache (CHTA) is loaded

Create the httpd script:

`zfile echo "#!CHTA" > /bin/httpd
zfile cat /bin/httpd` (this should display `#!CHTA`)

Mark the script as executable:

`zfile chmod 755 /bin/httpd`

(See "ZFILE-Activate a TPF Segment or Script" in the Operations guide for more information: http://www.ibm.com/tpf/pubs/tpfpubs.htm.)

### ZFILE example 1

`zfile httpd -v`

`FILE0001I 11.43.09 START OF DISPLAY FROM httpd -v
Server version: Apache/1.3.20 (TPF)
Server built: May 23 2001 09:39:22
END OF DISPLAY`

### ZFILE example 2

`zfile httpd -t -f /usr/local/apache/conf/alt.conf`

`FILE0002I 11.47.26 START OF ERROR DISPLAY FROM httpd -t ...
Syntax OK
END OF DISPLAY`

### ZINET XPARM example

This example uses an alternate configuration file called /usr/local/apache/conf/alt.conf.
Transfer the alternate configuration file to your TPF test system.
`zinet add s-apache pgm-chta model-daemon user-root xparm--f conf/alt.conf`
`zinet start s-apache`

(See "ZINET ADD-Add an Internet Server Application Entry" and "ZINET ALTER-Change an Internet Server Application Entry" in the Operations guide for more information about using the XPARM field: http://www.ibm.com/tpf/pubs/tpfpubs.htm.)

## Syslog Daemon

### Syslog overview:

The syslog daemon is a server process that provides a message logging facility for application and system processes. It can be used to write messages to log files or to tapes. See TPF Transmission Control Protocol/Internet Protocol for detailed information about using the syslog daemon on TPF: http://www.ibm.com/tpf/pubs/tpfpubs.htm. And see the Apache ErrorLog directive documentation for details on how to use syslog with Apache.

Syslog capabilities were added with PJ27214 which shipped with PUT13. You must follow the syslog specific installation instructions in order to have the option of using syslog with Apache.

### Tips on using syslog with your Apache error log:

This section provides some tips on using syslog with Apache. It is not meant to replace the syslog documentation in the TPF TCP/IP publication.

- The syslog daemon will not create files. If you are logging to a file (as specified in the `syslog.conf` configuration file) that file must already exist and have permissions that allow the syslog daemon to write to it.
- You must restart the syslog daemon for it to recognize changes to its `syslog.conf` configuration file.
- The syslog daemon must be active prior to starting Apache.
- To indicate you want to use syslog with your Apache error log add the following directive to your `httpd.conf` file: "`ErrorLog syslog:`facility" where facility is "local0" through "local7".
- Apache will default the facility to "local7" if you omit the facility name from the ErrorLog directive (that is "`ErrorLog syslog`").
- The syslog facility name must be one that is recognized by both Apache and the syslog.h header file. The facility names "local0" through "local7" are explicitly set aside for your use.
- Although "local0" through "local7" are recommended user facility names, here is the complete list of names recognized by both Apache and TPF's syslog.h: auth, cron, daemon, kern, local0, local1, local2, local3, local4, local5, local6, local7, lpr, mail, news, syslog, user, and uucp.
- You won't see the normal Apache startup/shutdown messages when you use syslog with your Apache error log.
- Syslog does not support TCP/IP Offload devices (ZCLAW)

## Porting Notes

### Changes made due to differences between UNIX and TPF's process models:

- Signals: On TPF a signal that is sent to a process remains unhandled until the process explicitly requests that signals be handled using the `tpf_process_signals()` function. Additionally, the default action for an alarm on TPF is to take an OPR-7777 dump and exit. (On UNIX the default is the equivalent of `exit()` with no dump taken.) These differences necessitated a few modifications:
- - bypass the use of `ap_block_alarms()` & `ap_unblock_alarms()`
  - add `tpf_process_signals()` calls
  - add `select()` calls to prevent blocking.

### Find that function...

Some simple functions & definitions initially needed to be added on TPF, such as `FD_SET()`. We've put these in src/os/tpf/os.h for now.

### EBCDIC changes:

TPF-specific conversion tables between US-ASCII and EBCDIC (character set IBM-1047 to be exact) were created.

### Miscellaneous, minor changes:

Various minor changes (such as casting) were made due to differences in how some functions are implemented on TPF.

[ top | Configuration Files | What's Available | CGI Scripts | Options | Syslog | Porting Notes ]